#include <fstream>
#include <iostream>

#include "../viz/stl.h"
//#include "utils.h"

void dummy_qual(int n, fstream& fout) {
  fout << ">0\n";
  for (int i = 0; i < n; ++i) fout << "0 ";
  fout << endl;
}

int main(int argc, char **argv) {
  if (argc != 6) {
	  cout << "Usage:org-seq, orgrc-seq, seed-len, seed-cov, harvard-cov" << endl;
	  exit(1);
  }
  char b[] = {'A', 'T', 'G', 'C'};
  fstream forg(argv[1], ios::in);
  fstream forgrc(argv[2], ios::in);
  fstream fseed("tmp/seed.fasta", ios::out);
  fstream fpair("tmp/pair.fasta", ios::out);
  fstream fqual("tmp/pair.qual", ios::out);
  fstream fcontigs("tmp/pair.contigs", ios::out);

  // Generate the original sequence first
  string org;
  forg >> org;
  string orgrc;
  forgrc >> orgrc;
  int seq_len = org.size();
//   org.resize(seq_len);
//   for (int i = 0; i < seq_len; ++i) {
//     org[i] = b[rand() % 4];
//   }
//   //  cout << org << endl;
//   forg << org << endl;

  // Generate the seeded reads.
  int seed_len = atoi(argv[3]);
  int total = 0;
  double cov = 0;
  while (cov < atof(argv[4])) {
    int pos = 1500 + rand() % (seq_len - seed_len + 1500);
    //    if (pos < 1500 || pos > seq_len - 1500) continue;
    //cout << ">" << pos << endl;
    fseed << ">" << pos << endl;
    //cout << org.substr(pos, seed_len) << endl;
    if (rand() % 2) {
      fseed << org.substr(pos, seed_len) << endl;
    } else {
      fseed << orgrc.substr(pos, seed_len) << endl;
    }
    total += seed_len;
    cov = (double)total / seq_len;
  }

  total = 0;
  cov = 0;
  while (cov < atof(argv[5])) {
    int pos = rand() % (seq_len - (18 + 1200 + 18));
    //    cout << ">" << pos << endl; 
    fpair << ">" << pos << endl; 
    if (rand() % 2) {  // 4 gaps
      //      cout << org.substr(pos, 7) << org.substr(pos + 11, 6) << endl;
      if (rand() % 2) {
	fpair << org.substr(pos, 7) << org.substr(pos + 11, 6) << endl;
	fcontigs << org.substr(pos, 7) << "NNNN" << org.substr(pos + 11, 6) << endl;
      } else {
	fpair << orgrc.substr(pos, 7) << orgrc.substr(pos + 11, 6) << endl;
	fcontigs << orgrc.substr(pos, 7) << "NNNN" << orgrc.substr(pos + 11, 6) << endl;
      }
      // total += 17;
      dummy_qual(17, fqual);
    } else {  // 5 gaps
      //      cout << org.substr(pos, 7) << org.substr(pos + 12, 6) << endl;
      if (rand() % 2) {
	fpair << org.substr(pos, 7) << org.substr(pos + 12, 6) << endl;
	fcontigs << org.substr(pos, 7) << "NNNN?" << org.substr(pos + 12, 6) << endl;
      } else {
	fpair << orgrc.substr(pos, 7) << orgrc.substr(pos + 12, 6) << endl;
	fcontigs << orgrc.substr(pos, 7) << "NNNN?" << orgrc.substr(pos + 12, 6) << endl;
      }
      //total += 18;
      dummy_qual(18, fqual);
    }
    
    // Get the starting position of the other mar.
    pos = pos + 1000 + (rand() % 2 ? 1 : -1) * (rand() % 200);
    //    cout << ">" << pos << endl; 
    fpair << ">" << pos << endl; 
    if (rand() % 2) {  // 4 gaps
      //cout << org.substr(pos, 7) << org.substr(pos + 11, 6) << endl;
      if (rand() % 2) {
	fpair << org.substr(pos, 7) << org.substr(pos + 11, 6) << endl;
	fcontigs << org.substr(pos, 7) << "NNNN" << org.substr(pos + 11, 6) << endl;
      } else {
	fpair << orgrc.substr(pos, 7) << orgrc.substr(pos + 11, 6) << endl;
	fcontigs << orgrc.substr(pos, 7) << "NNNN" << orgrc.substr(pos + 11, 6) << endl;
      }
      //total += 17;
      dummy_qual(17, fqual);
    } else {  // 5 gaps
      //cout << org.substr(pos, 7) << org.substr(pos + 12, 6) << endl;
      if (rand() % 2) {
	fpair << org.substr(pos, 7) << org.substr(pos + 12, 6) << endl;
	fcontigs << org.substr(pos, 7) << "NNNN?" << org.substr(pos + 12, 6) << endl;
      } else {
	fpair << orgrc.substr(pos, 7) << orgrc.substr(pos + 12, 6) << endl;
	fcontigs << orgrc.substr(pos, 7) << "NNNN?" << orgrc.substr(pos + 12, 6) << endl;
      }
      //total += 18;
      dummy_qual(18, fqual);
    }
    total += 26;
    cov = (double)total / seq_len;
  }
  return 0;
}
